
#property indicator_separate_window
#property indicator_buffers   4
#property indicator_color1    DarkGray
#property indicator_color2    LimeGreen
#property indicator_color3    PaleVioletRed
#property indicator_color4    PaleVioletRed
#property indicator_width2    2
#property indicator_width3    2
#property indicator_width4    2
#property indicator_minimum   0
#property indicator_maximum 100
#property indicator_level1   20
#property indicator_level2   80
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int  RsiPeriod       = 14;
extern int  Price           = PRICE_CLOSE;
extern int  AveragePeriod   = 25; 
extern int  AverageMethod   = MODE_EMA;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;


//
//
//
//
//

double rsi[];
double rsia[];
double rsiada[];
double rsiadb[];
double slope[];
double nlag[];
string shortName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,rsi);
      SetIndexBuffer(1,rsia);
      SetIndexBuffer(2,rsiada);
      SetIndexBuffer(3,rsiadb);
      SetIndexBuffer(4,slope);
      SetIndexBuffer(5,nlag);
   IndicatorShortName("Rsi ("+RsiPeriod+")");
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      if (slope[limit]==-1) CleanPoint(limit,rsiada,rsiadb);
      for(i=limit; i>=0; i--) rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
      for(i=limit,r=Bars-i-1; i>=0; i--,r++)
      {
        double nOsc[];
          nOsc[r] = rsi[i];
          rsia[i] = iNoLag(nOsc,1,15,r,i);
          
          rsiada[i] = EMPTY_VALUE;
          rsiadb[i] = EMPTY_VALUE;
          slope[i]  = slope[i+1];
            if (rsia[i]>rsia[i+1]) slope[i] =  1;
            if (rsia[i]<rsia[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,rsiada,rsiadb,rsia);
     
     
          
          
        
        if (ArrayRange(nOsc,0) != Bars) ArrayResize(nOsc,Bars);

 
        

Comment("nlag == ", nlag[i] ); 
         
     
      }       
      
      
     
   return(0);
}



//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//




//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2
#define Pi 3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2 

 
//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

#define Pi 3.14159265358979323846264338327950288
#define _length  0
#define _len     1
#define _weight  2 

double nvalues[][3];
double nlalpha[];

double iNoLag( double &price[], int forvalue, int length, int r,int i)
{ 
   
   int forValue = forvalue-1;
   if (length<3) return(price[r]);
   
  
   if (ArrayRange(nvalues,0)<(forValue+1) || nvalues[forValue][_length] != length)
   {
      double Cycle = 4.0;
      double Coeff = 3.0*Pi;
      int    Phase = length-1;
      
      if (ArrayRange(nvalues,0)<forValue+1) ArrayResize(nvalues,forValue+1);

         nvalues[forValue][_length] = length;
         nvalues[forValue][_len]    = length*4 + Phase;  
         nvalues[forValue][_weight] = 0;  
         ArrayResize(nlalpha,nvalues[forValue][_len]);

         for (int k=0; k<nvalues[forValue][_len]-1; k++)
         {
            if (k<=Phase-1) 
                 double t = 1.0 * k/(Phase-1);
            else        t = 1.0 + (k-Phase+1)*(2.0*Cycle-1.0)/(Cycle*length-1.0); 
            double beta = MathCos(Pi*t);
            double g = 1.0/(Coeff*t+1); if (t <= 0.5 ) g = 1;
      
            nlalpha[k]                  = g * beta;
            nvalues[forValue][_weight] += nlalpha[k];
         }
   }
     
   if (nvalues[forValue][_weight]>0)
   {
      int    len = nvalues[forValue][_len];
      double sum = 0;
           for (k=0; k < len-1; k++) sum += nlalpha[k]*price[r-k];      
           return( sum / nvalues[forValue][_weight]);
   }
   else return(0);           
}  